var Loader = require('./loader');

module.exports = BaseClass = function (options) {
	if (!options.model) throw new Error('You cannot create a class without a model defined');
	if (!options.collection) throw new Error('You cannot create a class without a collection defined');

	var classToReturn = {
		model: options.model
	};

	Loader.apply(classToReturn, [options.collection, options.model]);
	
	// grab all custom function from the objectExtension and bring it accross
	for (var property in options) {
		if (typeof options[property] === 'function') {
			classToReturn[property] = options[property];
		}
	}

	return classToReturn;
};
